/*
 *  JExtFileNameFilter.java
 *
 *  Created on 21.09.2009, 13:59:46
 *
 *  Copyright (C) 21.09.2009  reiner

 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */


/**
 *
 * @author reiner
 */

package shared.files;

import java.io.File;
import java.io.FilenameFilter;

public class JExtFileNameFilter implements FilenameFilter
{
    private String[] m_extArray;
    private boolean m_bListFolders;

    public JExtFileNameFilter(String ext, boolean bListFolders)
    {
        m_extArray = new String[1];
        m_extArray[0] = ext;
        m_bListFolders= bListFolders;
    }

    public JExtFileNameFilter(String[] ext, boolean bListFolders)
    {
        m_extArray = ext;
        m_bListFolders= bListFolders;
    }

    public boolean accept(File dir, String name)
    {
       String str = dir != null ? dir.getPath() : "";
       str = JPathHelper.addSeparator(str) + name;
       File file = new File(str) ;
       if (file.isDirectory())
       {
            if (m_bListFolders)
                return true;
       }
       else
       {
           String ext = JPathHelper.getFileExtension(name);
            for (String extName : m_extArray)
            {
                if (extName.equalsIgnoreCase(ext))
                    return true;
            }
       }
        return false;
    }
}
