/*
 * FtpNotify.java
 *
 * Created on 10. Dezember 2006, 11:34
 *
 *  Copyright (C) 10. Dezember 2006  <reiner>
 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */


package shared.ftp;

import shared.proglistener.ProgNotify;

/**
 *
 * @author reiner
 */

public class FtpNotify<T>  extends ProgNotify
{
    public static final int TYPE_LIST = 1;
    public static final int TYPE_RETR = 2;
    public static final int TYPE_STOR = 3;
    public static final int TYPE_TRANSFER = 4;
    protected int m_type;
    protected T m_data;
    
    /** Creates a new instance of JFtpNotify */
    
    public FtpNotify(int type)
    {
        m_type = type;
        m_data = null;
    }

    public FtpNotify(int type, int reason, T data)
    {
        super(reason);
        m_type = type;
        m_data = data;
    }
    
    public FtpNotify(int type, int reason)
    {
        super(reason);
        m_type = type;
    }

    public int getType()
    {
    	return m_type;
    }
    
    public T getData()
    {
        return m_data;
    }
}
