/*
 * JFtpFile.java
 *
 * Created on 17. Dezember 2006, 21:59
 *
 *  Copyright (C) 17. Dezember 2006  <reiner>
 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */


package shared.ftp;

import java.util.Calendar;

/**
 *
 * @author reiner
 */

public class JFtpFile
{
    public static final int TYPE_UNKNOWN  = 0;
    public static final int TYPE_FILE  = 1;
    public static final int TYPE_DIRECTORY  = 2;
    public static final int TYPE_LINK  = 3;
    
    protected int m_type = TYPE_UNKNOWN;
    protected String m_name;
    protected String m_user;
    protected String m_group;
    protected String m_rights;
    protected int m_hardLinks = 0;
    protected Calendar m_timeStamp = null;
    protected long m_size = 0;
    
    /** Creates a new instance of JFtpFile */
    public JFtpFile()
    {
    }
    
    public boolean isDirectory()
    {
        return m_type == TYPE_DIRECTORY;
    }
    
    public void setName(String name)
    {
        m_name = name;
    }

    public String getName()
    {
        return m_name;
    }

    public void setType(int type)
    {
        m_type = type;
    }
    
    public void setUser(String user)
    {
        m_user = user;
    }

    public void setGroup(String group)
    {
        m_group = group;
    }

    public void setRights(String rights)
    {
        m_rights = rights;
    }
    
    public String getRights()
    {
        return m_rights;
    }

    public void setNumberOfHardLinks(int hardLinks)
    {
        m_hardLinks = hardLinks;
    }

    public int getNumberOfHardLinks()
    {
        return m_hardLinks;
    }

    public void setSize(long size)
    {
        m_size = size;
    }

    public long getSize()
    {
        return m_size;
    }

    public void setTimeStamp(Calendar timeStamp)
    {
        m_timeStamp = timeStamp;
    }

    public Calendar getTimeStamp()
    {
        return m_timeStamp;
    }
    
    public static String removeRoot(String fileName)
    {
        String str = fileName;
        if (fileName != null && fileName.length() > 0 && fileName.charAt(0) == '/')
            str = fileName.substring(1);
        return str;
    }
}
