/*
 *  JValueHolder.java
 *
 *  Created on 21.03.2009, 12:29:30
 *
 *  Copyright (C) 21.03.2009, 12:29:30  <reiner>

 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */

package shared.valueholder;

public class JValueHolder <T>
{
    private String m_text;
    private String m_description;
    private T m_value;

    public JValueHolder()
    {
        m_text = "";
        m_description = "";
        m_value = null;
    }

    public JValueHolder(String text, T val)
    {
        m_text = text;
        m_value = val;
    }

    public JValueHolder(String text, String description, T val)
    {
        m_text = text;
        m_description = description;
        m_value = val;
    }

    public void setText(String str)
    {
        m_text = str;
    }
    public String getText()
    {
        return m_text;
    }

    @Override
    public String toString()
    {
        return getText();
    }

    public void setDescription(String str)
    {
        m_description = str;
    }
    public String getDescription()
    {
        return m_description;
    }

    public void setValue(T val)
    {
        m_value = val;
    }
    public T getValue()
    {
        return m_value;
    }
}
