/*
 *  WinJStart.cpp
 *
 *  Created on 8. May 2006, 18:35
 *
 *  Copyright (C) 8. May 2006  <Reiner>

 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */

// WinJStart.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <winerror.h>

int StartJava(TCHAR* cmd, const TCHAR* dir, bool bDisableRedirect)
{
	int err = 0;
	STARTUPINFO si;
	PROCESS_INFORMATION pi;
	PVOID oldVal = NULL;
	BOOL (_stdcall *pWow64DisableWow64FsRedirection)(void*) = NULL;
	BOOL (_stdcall *pWow64RevertWow64FsRedirection)(void*) = NULL;

	HMODULE hMod = NULL;
	if (bDisableRedirect)
	{
		hMod = LoadLibrary("kernel32.dll");
		if (hMod != NULL)
		{
			pWow64DisableWow64FsRedirection = (BOOL (__stdcall *)(void*))GetProcAddress(hMod, "Wow64DisableWow64FsRedirection");
			pWow64RevertWow64FsRedirection = (BOOL (__stdcall *)(void*))GetProcAddress(hMod, "Wow64RevertWow64FsRedirection");
		}
		if (pWow64DisableWow64FsRedirection != NULL)
			(*pWow64DisableWow64FsRedirection)(oldVal);
	}

	ZeroMemory(&si, sizeof(STARTUPINFO));
	ZeroMemory(&si, sizeof(PROCESS_INFORMATION));
	si.cb = sizeof(si);
	si.wShowWindow = SW_HIDE;
	si.dwFlags = STARTF_USESHOWWINDOW;
	if (!CreateProcess(NULL, cmd, NULL, NULL, FALSE, 0, NULL, dir, &si, &pi))
		err = GetLastError();
	CloseHandle(pi.hProcess);
	CloseHandle(pi.hThread);
	if (bDisableRedirect && pWow64RevertWow64FsRedirection != NULL)
		(*pWow64RevertWow64FsRedirection)(oldVal);
	if (hMod != NULL)
		FreeLibrary(hMod);
	return err;
}

int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE  hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	TCHAR cmd[8192], buf[_MAX_PATH], buf2[_MAX_PATH], curDir[_MAX_PATH];
	TCHAR drive[_MAX_DRIVE], dir[_MAX_DIR], name[_MAX_FNAME];

	GetModuleFileName(NULL, buf, _MAX_PATH);
	_splitpath(buf, drive, dir, name, NULL);
	lstrcpy(buf, "\"");
	lstrcat(buf, drive);
	lstrcat(buf, dir);
	lstrcat(buf, name);
	lstrcat(buf, _T(".jar"));
	lstrcat(buf, "\"");

	lstrcpy(curDir, drive);
	lstrcat(curDir, dir);

	lstrcpy(cmd, "\"java.exe\" -jar");
	lstrcat(cmd, _T(" "));
	lstrcat(cmd, buf);

	if (StartJava(cmd, curDir, true) == ERROR_FILE_NOT_FOUND)
	{
		if (StartJava(cmd, curDir, false) == ERROR_FILE_NOT_FOUND)
			MessageBox(NULL, _T("You must install the Java Runtime from Sum Microsystems Inc.!\nYou can find it under http://www.java.com"), _T("Java Runtime missing"), MB_ICONSTOP);
	}
	return 0;
}

